︠cb3bf1fc-e981-4eb9-b0c9-e65a9a78cd06i︠
%html
<p>This is a modified (higher degree) version <a title="sage-devel thread on &quot;reusing solutions in functions&quot;" href="http://groups.google.com/group/sage-devel/browse_thread/thread/9767e3a8d538438d/26f9ebe8dc72e58d#26f9ebe8dc72e58d" target="_blank">Harald's example</a>.&nbsp; We solve a pair of equations in a pair of unknowns:</p>

︡346e4eeb-85e1-411e-b8c3-b111b75a5734︡{"html": "<p>This is a modified (higher degree) version <a title=\"sage-devel thread on &quot;reusing solutions in functions&quot;\" href=\"http://groups.google.com/group/sage-devel/browse_thread/thread/9767e3a8d538438d/26f9ebe8dc72e58d#26f9ebe8dc72e58d\" target=\"_blank\">Harald's example</a>.&nbsp; We solve a pair of equations in a pair of unknowns:</p>"}︡
︠023f9372-756e-41c7-a1a7-3dc323ce27a9︠
var('y x')
sol = solve([x + y^2 == 6, x^2 - y == 4], x, y)
sol
︡158db22e-ad45-4d6d-91ac-08ae5e8cf8c4︡{"html": "<span class=\"math\">\\begin{array}{l}[\\left[x  =  2.42698224852, \n y  =  1.8902427767\\right],\\\\\n\\left[x  =  1.35852568876, \n y  =  -2.15440792906\\right],\\\\\n\\left[x  =  -1.15142718916, \n y  =  -2.67421513124\\right],\\\\\n\\left[x  =  -2.63408071749, \n y  =  2.93838061244\\right]]\\end{array}</span>"}︡
︠62764380-c35b-402f-b221-3c2e64bda97ei︠
%html
<p>We wish to apply a function <span style="font-family: andale mono,times;">f</span> of two variables to each of these solutions:</p>

︡88ca8d9f-6386-4556-817b-c1b12f093f1d︡{"html": "<p>We wish to apply a function <span style=\"font-family: andale mono,times;\">f</span> of two variables to each of these solutions:</p>"}︡
︠3c4cf1c3-9a77-445a-af18-8266f7e34354︠
f = 2*x + y
f
︡6b2be39e-3cd4-4f96-a0d6-1dfda0229d8b︡{"html": "<span class=\"math\">y + {2 x}</span>"}︡
︠7de1b7d4-93ff-4765-b6ac-489bef6afa20i︠
%html
<p>Here's one approach, using Python's built-in <span style="font-family: andale mono,times;">map()</span> function and a <span style="font-family: andale mono,times;">lambda</span>, or "anonymous," function.&nbsp; We note that this depends on the two values being in a specific order (first <span style="font-family: andale mono,times;">x</span>, then <span style="font-family: andale mono,times;">y</span>) for all solutions in <span style="font-family: andale mono,times;">sol</span>:</p>

︡bcce73ff-16ba-490b-ba3f-48f22bc9dd39︡{"html": "<p>Here's one approach, using Python's built-in <span style=\"font-family: andale mono,times;\">map()</span> function and a <span style=\"font-family: andale mono,times;\">lambda</span>, or \"anonymous,\" function.&nbsp; We note that this depends on the two values being in a specific order (first <span style=\"font-family: andale mono,times;\">x</span>, then <span style=\"font-family: andale mono,times;\">y</span>) for all solutions in <span style=\"font-family: andale mono,times;\">sol</span>:</p>"}︡
︠c46b63b7-2ca0-4377-92fd-74c53b0aca09︠
map(lambda s: f(s[0].rhs(), s[1].rhs()), sol)
︡a497959a-5ef0-401f-8827-69b48a930063︡{"html": "<span class=\"math\">\\left[6.74420727374, \n 0.562643448457, \n -4.97706950957, \n -2.32978082254\\right]</span>"}︡
︠288f3cdd-c55d-416a-883b-046acd77b43bi︠
%html
<p>However, we do not need to know the number of variables in advance.&nbsp; Let's use Python's <span style="font-family: andale mono,times;">*</span> operator, which converts a list into an argument list, and nested list comprehensions (why not?), to define another higher-order function:</p>

︡f6b46f00-94d3-497a-8632-e093fb09b2d6︡{"html": "<p>However, we do not need to know the number of variables in advance.&nbsp; Let's use Python's <span style=\"font-family: andale mono,times;\">*</span> operator, which converts a list into an argument list, and nested list comprehensions (why not?), to define another higher-order function:</p>"}︡
︠f3fac9d6-ec14-442c-a0dc-1010c9cfe8bb︠
def apply_func_to_sols(func, sols):
    return map(lambda x: func(*x), [[s.rhs() for s in t] for t in sols])
︡4349d69c-dff7-4dea-b5f6-95b26338add7︡︡
︠0f428ce2-b77b-4d9b-a13b-89a2ebe3ed81i︠
%html
<p>Again, we obtain the value of <span style="font-family: andale mono,times;">f</span> "on" each of the solutions in <span style="font-family: andale mono,times;">sol</span>:</p>

︡aae0f1e0-6ef7-4533-a8a5-e0ab5eb185b0︡{"html": "<p>Again, we obtain the value of <span style=\"font-family: andale mono,times;\">f</span> \"on\" each of the solutions in <span style=\"font-family: andale mono,times;\">sol</span>:</p>"}︡
︠7af9f6f8-d39e-463d-b12b-a568dd7a0207︠
apply_func_to_sols(f, sol)
︡f9ca2152-5a60-4beb-9120-117aa6c2782b︡{"html": "<span class=\"math\">\\left[6.74420727374, \n 0.562643448457, \n -4.97706950957, \n -2.32978082254\\right]</span>"}︡
︠8048a66c-da09-4712-a1f1-15248d96c177i︠
%html
<p>Finally, we simplify the recipe to get the same result:</p>

︡d14a49c8-536d-4c2e-a115-60f8f846fbd3︡{"html": "<p>Finally, we simplify the recipe to get the same result:</p>"}︡
︠25c7fb46-18c8-473a-a291-7d9bed190907︠
def rhs(eq):
    return eq.rhs()
[f(*map(rhs, s)) for s in sol]
︡694597f6-25cb-47a1-a8e2-b8428adfd250︡{"html": "<span class=\"math\">\\left[6.74420727374, \n 0.562643448457, \n -4.97706950957, \n -2.32978082254\\right]</span>"}︡
︠2675f208-02c6-4396-b439-0019779bcd5ci︠
%html
<p>That was spectacular.</p>

︡b25941b0-60ed-4b7f-a19c-3772552af1ed︡{"html": "<p>That was spectacular.</p>"}︡
